;/*******************/;
;/* Delay Time 1 mS */;
;/* CPU Bus = 8 MHz */;
;/* 1Cycle = 1/8MHz */;
;/* 1mS = 8000Cycle */;
;/* Input :DLY_BUFF */;
;/*******************/;
;
DLY_MSEC:   PSHH                            ; Save Register (2 Cycle)
            PSHX                            ; 2 Cycle
            PSHA                            ; 2 Cycle
            TPA                             ; CCR -> A (1 Cycle)
            PSHA                            ; 2 Cycle
            LDA     DLY_BUFF                ; 3 Cycle (Get Delay)
            ;
DLY_MS0:    LDHX    #886                    ; 3 Cycle
DLY_MS1:    NOP                             ; 1 Cycle
            AIX     #-1                     ; H:X - 1 (2 Cycle)
            CPHX    #0                      ; 3 Cycle
            BNE     DLY_MS1                 ; 3 Cycle ( 9 x 886 = 8000 Cycle)
            DBNZA   DLY_MS0                 ; 3 Cycle
            ;
            PULA                            ; 2 Cycle
            TAP                             ; A -> CCR (2 Cycle)
            PULA                            ; 2 Cycle
            PULX                            ; 2 Cycle
            PULH                            ; 2 Cycle
            RTS                             ; 4 Cycle

;/*******************/;
;/* Upper Case Char */;
;/* Input  : A      */;
;/* Output : A      */;
;/*******************/;
;
UP_CHAR:    CMP     #"a"                ; Start Upper Case
            BLO     UP_CHR1
            CMP     #"z"                ; End Upper Case
            BHI     UP_CHR1
            SUB     #20H                ; Convert 'a..z' to 'A..Z'
UP_CHR1:    RTS

;/************************/;
;/* Convert HEX to ASCII */;
;/* Input  : A (HEX)     */;
;/* Output : A (ASCII)   */;
;/************************/;
;
HEX_ASCII:  AND     #0FH                ; Clear High Nibble
            CMP     #9
            BHI     HEX_ASC1            ; A..F Jump
            ADD     #30H                ; Convert 0..9 to '0..9'
            BRA     HEX_ASC2
            ;
HEX_ASC1:   SUB     #9                  ; Convert A..F to 1..6
            ADD     #40H                ; Convert 1..6 to 'A..F'
            ;
HEX_ASC2:   RTS

;/************************/;
;/* Convert ASCII to HEX */;
;/* Input  : A (ASCII)   */;
;/* Output : A (HEX)     */;
;/************************/;
;
ASCII_HEX:  CMP     #"0"
            BLO     ASC_HEX2            ; Not ASCII
            CMP     #"9"
            BLS     ASC_HEX1            ; 30H..39H Jump
            CMP     #"A"
            BLO     ASC_HEX2            ; Not ASCII
            CMP     #"F"
            BHI     ASC_HEX2            ; Not ASCII
            ADD     #9                  ; Convert 'A..F' to 4AH..4FH
ASC_HEX1:   AND     #0FH                ; Convert ASC to HEX
            ;
ASC_HEX2:   RTS
            
;/********************************/;
;/* Print ASCII Data to LCD Port */;
;/* Usage    : JSR  PRINT_LCD    */;
;/*          : FCC  'xxxxxxxx'   */;
;/*          : FCB  $00          */;
;/* Note     : Last Byte = $00   */;
;/********************************/;
;
PRINT_LCD:  PULH                        ; Pop Stack PCH
            PULX                        ; Pop Stack PCL
            PSHA
            ;
PRN_LCD1:   LDA     0,X                 ; Get Data For Print
            BEQ     PRN_LCD2            ; If Last Byte Jump
            JSR     WR_LCD              ; Write Data to LCD
            INCX
            BRA     PRN_LCD1
            ;
PRN_LCD2:   INCX                        ; Skip Last Byte
            ;
            PULA
            PSHX                        ; Push PCL to Stack
            PSHH                        ; Push PCH to Stack
            RTS

            END

